;
; ======================================================
;
;   CANLIN.asm		9S12XDT512 Test File
;
;   Version:		1.0   12/03/04
;   Author:		      Spencer Ruggles
;   Compiler:		AS12
;
;   Platform:		Axiom CML-12C32
;   Purpose:		Toggle CAN and LIN port signals
; ======================================================
;


;#include 12XEqu.asm		; register equates file

;========== Local Equates ==============================

;REGBS:	equ $0			; reg base starts at 0
;RAM:	equ $2000		; start of RAM
;STACK:	equ $4000		; SP, top of RAM + 1
EOT:  	equ 0			; End of text character


;PSTART:
;        org RAM			; load program at RAM base

CANLIN:

;SETUP:

	movb #$ff,DDRS		; PTS[3:2] output
	movb #$02,DDRM		; PTM[1] output



PROG:
	movb #$00,PTM		; init PTM
      jsr OUTCRLF0		; blank line
      jsr OUTCRLF0		; blank line



;	ldx #CANTEST		; CAN Test Start
;	jsr OUTSTRG0		; send message

      jsr   M_CRLF
      jsr   String2
      fdb   MCAN              ; CAN Test
      fdb   MTest       
      jsr   M_CRLF            ; new line
      jsr   String2           ; Loop Back
      fdb   MLoop
      fdb   MBack


;      jsr OUTCRLF0		; blank line

	bset   PTM,$02		; PTM1 high
	brset  PTM,$01,FAILC	; get fail message
      bclr   PTM,$02		; PTM1 low
      brclr  PTM,#$01,FAILC	; get fail message

PASSC:
	
      jsr   String1           ; Passed
      fdb   MPassed
      	

; Continue toggle test
      jsr   M_CRLF
      jsr   M_CRLF
      jsr   String3
      fdb   MVerify           ; Verify CAN_PORT Pins
      fdb   MCAN_PRT
      fdb   MPins
      jsr   String3           ; 1 and 3
      fdb   M1
      fdb   Mand
      fdb   M3
      jsr   String2           ; are toggling
      fdb   Mare
      fdb   MTogglei          ;
      jsr   M_CRLF            ; new line
    

      ldaa SCI0SR1            ; read status
      ldaa SCI0DRL		; clear any chars

Can_Lp:
      fdiv                    ; delay 12 cycles
      bset   PTM,$02		; PTM1 high
      fdiv                    ; delay 12 cycles
      bclr   PTM,$02		; PTM1 low
      brclr  SCI0SR1,#RDRF,Can_Lp ; loop until input avail
	ldaa   SCI0DRL		; get input data

;      jsr    Sci_In
      lbra  Menu              ; return to menu  
	
FAILC:
	jsr   String1		; Failed
      fdb   MFailed
      jsr   Sci_In            ; wait for operator
	lbra Menu





; ========== SUB-ROUTINES ===============================

DELAY:

	psha			; store A
	pshx			; store X

	ldaa #$00		; outer loop count
DLYO:	ldx #$000F		; inner loop count
DLYI:	dex			; X = X-1
	bne DLYI		; inner delay loop
	deca
	bne DLYO		; outer delay loop

	pulx			; restore X
	pula			; restore A

	rts			; return



		

