;
; =================================================
;
;   J2_350.asm		9S12XDT512 Test File
;
;   Version:		1.0   02/08/05
;   Author:		      Gary Karnes
;   Compiler:		AS12
;
;   Platform:		DEMO9S12XDT512
;   Purpose:		Check I/O pins on J2
; =================================================
;
; This test requires a loop back board
; The loop board should have the following
;   PB0 - PB1  shorted      41,43
;   PB2 - PB3  shorted      45,47
;   PE2 - PE3  shorted      73,75
;   PT4 - PB5  shorted      49,51
;   PB6 - PB7  shorted      53,55
;   PT2 - PT3  shorted      46,48
;   PT4 - PT5  shorted      57,59
;   PT6 - PT7  shorted      61,63

; Setup Ports for toggling

J2_350:


; Setup Ports
        
         movb   #$55,DDRB        ; odd outputs
         movb   #$04,DDRE        ; PE2 as output
         movb   #$54,DDRT        ; PT2,4,6 as output


J2_Lp:

         jsr   M_CRLF
         jsr   M_CRLF
         jsr   String2
         fdb   MJ2           ; J2
         fdb   MTest         ; Test
         jsr   M_CRLF

         jsr   String3
         fdb   MInstall      ; Install Test Board
         fdb   MTest         ; 
         fdb   MBoard        ;
         jsr   PKEY          ; Press a key
         jsr   M_CRLF

;============================================================
; Test Port B

         clr     PORTB              ; set all outputs low
         idiv                       ; delay
         brclr   PORTB,$AA,J2_Nt1   ; skip to next test
         lbra    J2_B_F             ; report Failed
     

J2_Nt1:
          bset    PORTB,$55         ; set odd output high
          idiv                      ; delay
          brset   PORTB,$AA,J2_Nt2  ; skip to next test

J2_B_F:
         jsr     M_CRLF
         jsr     String2
         fdb     MPort          ; Port B
         fdb     MB             ; 
         jsr     M_CRLF

         lbra    Failed            ; report Failed

J2_Nt2:
;==============================================================
; Test Port E

          clr     PORTE             ;
          idiv                      ; delay
          brclr   PORTE,$08,J2_Nt3  ; skip to next test
          lbra    J2_E_F            ; report Failed

J2_Nt3:

          bset    PORTE,$04         ; set odd output high
          idiv                      ; delay
          brset   PORTE,$08,J2_Nt4  ; skip to next test

J2_E_F:

         jsr     M_CRLF
         jsr     String2
         fdb     MPort          ; Port E
         fdb     ME             ; 
         jsr     M_CRLF
         lbra    Failed            ; report Failed


J2_Nt4:
;================================================================
; Test Port T

          clr     PTT              ;
          idiv                     ; delay
          brclr   PTT,$A8,J2_Nt5   ; skip to next test
          lbra    J2_T_F           ; report Failed
             
J2_Nt5:

          bset    PTT,$54          ; set odd output high
          idiv                     ; delay
          brset   PTT,$A8,J2_Nt6   ; skip to next test

J2_T_F:

         jsr     M_CRLF
         jsr     String2
         fdb     MPort             ; Port T
         fdb     MT                ; 
         jsr     M_CRLF

         lbra    Failed            ; report Failed

J2_Nt6:
;=================================================================

          jsr     M_CRLF

         lbra    Passed
  






