;
; ======================================================
;
;   LIN_Tst.asm		9S12XDT512 Test File
;
;   Version:		1.0   01/14/05
;   Author:		      Spencer Ruggles
;   Revision:           Gary Karnes
;   Compiler:		AS12
;
;   Platform:		Axiom DEMO9S12XDT512
;   Purpose:		Toggle LIN port signals
; ======================================================
;

LIN_Tst:


	bset  DDRS,$08		; PTS[3] output
	movb #$02,DDRM		; PTM[1] output
      bset  DDRE,$04          ; PE2 as output
      bset  PORTE,$04         ; Enable LIN driver

PROG_A:

	movb #$00,PTM		; init PTM
      jsr OUTCRLF0		; blank line
      jsr OUTCRLF0		; blank line
	

; LIN Test

      jsr   M_CRLF
	
	ldx #LINTEST		; LIN Test Start
	jsr OUTSTRG0		; send message
	ldx #SCOPE		      ; OScope setup message
	jsr OUTSTRG0
	ldx #LTX		      ; Verify Waveform 
	jsr OUTSTRG0
	jsr OUTCRLF0		; blank line
	ldx #CONT		      ; Continue
	jsr OUTSTRG0		;
	jsr OUTCRLF0		; blank line
	jsr CLEAR		      ; clear SCI input	
TX:
	bset  PTS,$08		; TXD1 high
      jsr   LIN_Del           ; delay
      brclr  PTS,$04,FAILC	; get fail message

      bclr  PTS,$08		; TXD1 low
      jsr   LIN_Del           ; delay
      brset  PTS,$04,FAILC	; get fail message
      brset SCI0SR1,$20,NEXT	; branch on input
	bra TX			; return

NEXT:
;	ldx #LRX		; Verify Waveform
;	jsr OUTSTRG0
;	jsr OUTCRLF0		; blank line
;	ldx #FIN		; Finish
;	jsr OUTSTRG0
;	jsr CLEAR		; clear SCI input	
;RX:
;	movb #$04,PTS		; RXD1 high
;	NOP
;	NOP
;	movb #$00,PTS		; RXD1 low
;
;	brset SCI0SR1,$20,EXITTo	; branch on input
;	bra RX			; return

EXITTo:
	ldx #DONE		      ; Done
	jsr OUTSTRG0		
      lbra  Menu              ; return to menu  

; ========== SUB-ROUTINES ===============================

LIN_Del:

          ldx   #1000

LIN_Dell:

          dex
          bne   LIN_Dell
          rts

;






