;
* ============================================================
*
*   String.asm      Axiom String Driver for the Motorola Hc12 
*                                 
*   Version:        1.0   Released 8/26/2002
*   Author:         Gary Karnes , Axiom Mfg.
*   Compiler:       As12
*       
*   Platform:       Axiom CML12S
*   Purpose:        Displaying Strings
* 
* =============================================================
;
;  String:      Send a string to the com port
;  String1;     Send one string to com port
;  String2:     Send two strings to com port
;  String3:     send three strings to com port
; 
;
; Send one string to com port
; load 16 bit pointer after jsr
; sends space after string
; is calling from sub,sub
String1S:
         
         puld            ; get d (return address)
         puly            ; get the return Pc value
         ldx     0,y     ; string location pointed to by Pc
         iny             ; skip over string pointer
         iny
         pshy
         pshd            ; save d (return address)
         jsr     String  ; send string
         rts


String1:
          jsr     String1S  ; send one string + space
          rts
; Send two strings
; load two 16 bit pointer after jsr
; sends space after each string
String2:
         jsr    String1S     ; send one string
         jsr    String1S     ; send second string
         rts
; Send three strings
String3:
         jsr    String1S     ; send one string
         jsr    String1S     ; send two string
         jsr    String1S     ; send three string
         rts
;
; Send four strings
String4:
         jsr    String1S     ; send one string
         jsr    String1S     ; send two string
         jsr    String1S     ; send three string
         jsr    String1S     ; send three string
         rts
;

; Send a String
; Index register is loaded with address of string.
; continue until reading a zero.
String:
                
        ldaa    0,x      ; load byte from string
        beq     LSE      ; if zero then end
        pshx             ; save x
        jsr     Sci_Out   ; send character to lcd
        pulx              ; restore x
        inx
        bra     String
LSE     ldaa    #$20     ; add space
        jsr     Sci_Out
        rts
;
